import 'package:flutter_test/flutter_test.dart';
import 'package:easy_duration/easy_duration.dart';

void main() {
  test("Test second", () {
    final oneSeconds = 1.seconds;
    expect(oneSeconds.inSeconds, 1);
    final oneS = 1.s;
    expect(oneS.inSeconds, 1);
  });

  test("Test miliseconds", () {
    final oneMili = 2.miliseconds;
    expect(oneMili.inMilliseconds, 2);
    final tenMili = 10.ms;
    expect(tenMili.inMilliseconds, 10);
  });

  test("Test microsecond", () {
    final oneMicro = 1.microseconds;
    expect(oneMicro.inMicroseconds, 1);
    final tenMicro = 10.us;
    expect(tenMicro.inMicroseconds, 10);
  });

  test("Test minutes", () {
    final oneMinutes = 1.minutes;
    expect(oneMinutes.inMinutes, 1);
    final tenMinutes = 10.m;
    expect(tenMinutes.inMinutes, 10);
  });

  test("Test hours", () {
    final oneHour = 1.hours;
    expect(oneHour.inHours, 1);
    final tenHours = 10.h;
    expect(tenHours.inHours, 10);
  });

  test("Test day", () {
    final oneDay = 1.days;
    expect(oneDay.inDays, 1);
    final tenDays = 10.days;
    expect(tenDays.inDays, 10);
  });

  test("Test months", () {
    final oneMonth = 1.months;
    expect(oneMonth.inDays, 30);
    final tenMonths = 10.M;
    expect(tenMonths.inDays, 300);
  });

  test("Test years", () {
    final oneYear = 1.years;
    expect(oneYear.inDays, 365);
    final tenYears = 10.y;
    expect(tenYears.inDays, 3650);
  });

  test("Test weeks", () {
    final oneYear = 1.weeks;
    expect(oneYear.inDays, 7);
    final tenYears = 10.w;
    expect(tenYears.inDays, 70);
  });

  test("Test theDayAfter", () {
    final currentDate = DateTime(2021, 5, 9);
    final tomorrow = theDayAfter(currentDate);
    expect(tomorrow.day, 10);
  });

  test("Test theDayBefore", () {
    final today = DateTime(2021, 5, 9);
    final yesterday = theDayBefore(today);
    expect(yesterday.day, 8);
  });

  test("Test circles", () {
    final fourDays = 2.circles(2.d);
    expect(fourDays.inDays, 4);
    final sixMins = 2.circles(3.m);
    expect(sixMins.inMinutes, 6);
  });
}
